import win32.windows;
import win32.windef;
import win32.commctrl;
import std.stdio;
import std.string;
import std.utf;

import Spin;
import GraphicBaseEx;

class GraphicFrameTest : GraphicBaseEx {
  Spin scalespin ;

  this(string name, string ClassName) {
    super(name,ClassName) ;
  }

  override int wm_create(){
    return(0) ;
  }

  override int wm_paint(){
    return(0) ;
  }

  override int wm_size(int w, int h){
    return(0) ;
  }

  override int wm_mousewheel(int d, int key){
    if( (key & MK_CONTROL) !=0 ){
      if( d!=0 ){
        double scale=cast(double)(d)/120.0 ;
        if( scale < 0.0 ){
          scale = scalespin.getValue() * 0.9 ;
        }else{
          scale = scalespin.getValue() * 1.1 ;
        }
        setScale(scale/100.0) ;
        scalespin.setValue(scale) ;
      }
      return(1) ;
    }
    return(0) ;
  }

  override int mouse( int acs_stat, int mb, int mx, int my ){
    int w = getImageBufferWidth() ;
    int h = getImageBufferHeight() ;
    uint[][] imgbuf = getImageBuffer() ;
    if( my<h && mx<w && my>=0 && mx>=0 && (mb & LBUTTONDOWN)!=0  ){
      imgbuf[my][mx]=0 ;
    }
    return(1) ;
  }

  int setScaleSpin(Spin scalespin){
    if( scalespin !is null ){
      this.scalespin = scalespin ;
    }
    return(0) ;
  }
}
